commit:     2b1af680d5afaa6c5b11302e531d784996bc15f7
Author:     Anthony G. Basile <blueness <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 19 21:14:39 2021 +0000
Commit:     Anthony G. Basile <blueness <AT> gentoo <DOT> org>
CommitDate: Tue Jan 19 21:56:25 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=2b1af680

sys-libs/musl: version bump to 1.2.2

Package-Manager: Portage-3.0.13, Repoman-3.0.2
Signed-off-by: Anthony G. Basile <blueness <AT> gentoo.org>

 sys-libs/musl/Manifest          |   1 +
 sys-libs/musl/musl-1.2.2.ebuild | 133 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 134 insertions(+)

diff --git a/sys-libs/musl/Manifest b/sys-libs/musl/Manifest
index b395b0fd819..c2ab036a470 100644
--- a/sys-libs/musl/Manifest
+++ b/sys-libs/musl/Manifest
@@ -4,3 +4,4 @@ DIST iconv.c 2577 BLAKE2B 
070ca87b30c90ab98c27d5faf7a2fcb64ff7c67ca212ee6072165b
 DIST musl-1.1.24.tar.gz 1024988 BLAKE2B 
5fa26746eed0f2334b740adf94a8400568d56d9b2276bf1fbac828f9b707b4e215d3c16af9ea048b9d771f1d0a58ada3bc6e1bf0ba8f5fa693f5042fc6af30df
 SHA512 
8987f1e194ea616f34f4f21fe9def28fb7f81d7060e38619206c6349f79db3bbb76bae8b711f5f9b8ed038799c9aea1a4cbec69e0bc4131e246203e133149e77
 DIST musl-1.2.0.tar.gz 1035265 BLAKE2B 
0a47e0f438cca0f3ce31ae024c19358160214842115b560efc48e66228055c9147d9550957a79425322d510ba773f197d0944bb844bf6addbbf698088a3358a9
 SHA512 
58bd88189a6002356728cea1c6f6605a893fe54f7687595879add4eab283c8692c3b031eb9457ad00d1edd082cfe62fcc0eb5eb1d3bf4f1d749c0efa2a95fec1
 DIST musl-1.2.1.tar.gz 1047481 BLAKE2B 
5ccdee248d4caa1b433ab9c56cce3842fb46a269fd6a53d0880ba5eaad208997306e6b56fd345917e5076714fbfac0804ea226e6dc3f0f2e75f8c824a7155535
 SHA512 
455464ef47108a78457291bda2b1ea574987a1787f6001e9376956f20521593a4816bc215dab41c1a80292ae7ebd315accb4d4fa6a1210ff77d9a4d68239e960
+DIST musl-1.2.2.tar.gz 1055220 BLAKE2B 
a000357ed52e417d8cebe5537df658dc0f8f02f2da3efcd79125544ad63e11e05fa96136551d0bfeb09a3f6c9a2260bffcfbd329ea92e6a7b62aa690f48968aa
 SHA512 
5344b581bd6463d71af8c13e91792fa51f25a96a1ecbea81e42664b63d90b325aeb421dfbc8c22e187397ca08e84d9296a0c0c299ba04fa2b751d6864914bd82

diff --git a/sys-libs/musl/musl-1.2.2.ebuild b/sys-libs/musl/musl-1.2.2.ebuild
new file mode 100644
index 00000000000..393a73ebfeb
--- /dev/null
+++ b/sys-libs/musl/musl-1.2.2.ebuild
@@ -0,0 +1,133 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit eutils flag-o-matic multilib toolchain-funcs
+if [[ ${PV} == "9999" ]] ; then
+       EGIT_REPO_URI="git://git.musl-libc.org/musl"
+       inherit git-r3
+       SRC_URI="
+       https://dev.gentoo.org/~blueness/musl-misc/getconf.c
+       https://dev.gentoo.org/~blueness/musl-misc/getent.c
+       https://dev.gentoo.org/~blueness/musl-misc/iconv.c";
+       KEYWORDS=""
+else
+       SRC_URI="http://www.musl-libc.org/releases/${P}.tar.gz
+       https://dev.gentoo.org/~blueness/musl-misc/getconf.c
+       https://dev.gentoo.org/~blueness/musl-misc/getent.c
+       https://dev.gentoo.org/~blueness/musl-misc/iconv.c";
+       KEYWORDS="-* ~amd64 ~arm ~arm64 ~mips ~ppc ~ppc64 ~x86"
+fi
+
+export CBUILD=${CBUILD:-${CHOST}}
+export CTARGET=${CTARGET:-${CHOST}}
+if [[ ${CTARGET} == ${CHOST} ]] ; then
+       if [[ ${CATEGORY} == cross-* ]] ; then
+               export CTARGET=${CATEGORY#cross-}
+       fi
+fi
+
+DESCRIPTION="Light, fast and simple C library focused on standards-conformance 
and safety"
+HOMEPAGE="http://www.musl-libc.org/";
+LICENSE="MIT LGPL-2 GPL-2"
+SLOT="0"
+IUSE="headers-only"
+
+QA_SONAME="/usr/lib/libc.so"
+QA_DT_NEEDED="/usr/lib/libc.so"
+
+PATCHES=(
+       "${FILESDIR}/${P}-CVE-2020-28928.patch"
+)
+
+is_crosscompile() {
+       [[ ${CHOST} != ${CTARGET} ]]
+}
+
+just_headers() {
+       use headers-only && is_crosscompile
+}
+
+pkg_setup() {
+       if [ ${CTARGET} == ${CHOST} ] ; then
+               case ${CHOST} in
+               *-musl*) ;;
+               *) die "Use sys-devel/crossdev to build a musl toolchain" ;;
+               esac
+       fi
+
+       # fix for #667126, copied from glibc ebuild
+       # make sure host make.conf doesn't pollute us
+       if is_crosscompile || tc-is-cross-compiler ; then
+               CHOST=${CTARGET} strip-unsupported-flags
+       fi
+}
+
+src_configure() {
+       tc-getCC ${CTARGET}
+       just_headers && export CC=true
+
+       local sysroot
+       is_crosscompile && sysroot="${EPREFIX}"/usr/${CTARGET}
+       ./configure \
+               --target=${CTARGET} \
+               --prefix=${sysroot}/usr \
+               --syslibdir=${sysroot}/lib \
+               --disable-gcc-wrapper || die
+}
+
+src_compile() {
+       emake obj/include/bits/alltypes.h
+       just_headers && return 0
+
+       emake
+       if [[ ${CATEGORY} != cross-* ]] ; then
+               emake -C "${T}" getconf getent iconv \
+                       CC="$(tc-getCC)" \
+                       CFLAGS="${CFLAGS}" \
+                       CPPFLAGS="${CPPFLAGS}" \
+                       LDFLAGS="${LDFLAGS}" \
+                       VPATH="${DISTDIR}"
+       fi
+}
+
+src_install() {
+       local target="install"
+       just_headers && target="install-headers"
+       emake DESTDIR="${D}" ${target}
+       just_headers && return 0
+
+       # musl provides ldd via a sym link to its ld.so
+       local sysroot
+       is_crosscompile && sysroot=/usr/${CTARGET}
+       local ldso=$(basename "${D}"${sysroot}/lib/ld-musl-*)
+       dosym ${sysroot}/lib/${ldso} ${sysroot}/usr/bin/ldd
+
+       if [[ ${CATEGORY} != cross-* ]] ; then
+               # Fish out of config:
+               #   ARCH = ...
+               #   SUBARCH = ...
+               # and print $(ARCH)$(SUBARCH).
+               local arch=$(awk '{ k[$1] = $3 } END { printf("%s%s", 
k["ARCH"], k["SUBARCH"]); }' config.mak)
+               [[ -e "${D}"/lib/ld-musl-${arch}.so.1 ]] || die
+               cp "${FILESDIR}"/ldconfig.in "${T}" || die
+               sed -e "s|@@ARCH@@|${arch}|" "${T}"/ldconfig.in > 
"${T}"/ldconfig || die
+               into /
+               dosbin "${T}"/ldconfig
+               into /usr
+               dobin "${T}"/getconf
+               dobin "${T}"/getent
+               dobin "${T}"/iconv
+               echo 'LDPATH="include ld.so.conf.d/*.conf"' > "${T}"/00musl || 
die
+               doenvd "${T}"/00musl
+       fi
+}
+
+pkg_postinst() {
+       is_crosscompile && return 0
+
+       [ "${ROOT}" != "/" ] && return 0
+
+       ldconfig || die
+}

Reply via email to